commit 109403eb3943201ef8d52c80d6d619eda71b50bb
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Mon Feb 5 16:07:30 2024 +0530

    PS-9096 Compiling 5.7 fails with VS2022
    
    https://perconadev.atlassian.net/browse/PS-9096
    
    Bug#35967676 mysql/mysql-server@4611cc258e3
    
    Add the missing STL headers to allow compiling on VS2022.

diff --git a/sql/json_dom.h b/sql/json_dom.h
index 14d120fe838..6195960447f 100644
--- a/sql/json_dom.h
+++ b/sql/json_dom.h
@@ -34,6 +34,7 @@
 #include "sql_error.h"          // Sql_condition
 #include "prealloced_array.h"   // Prealloced_array
 
+#include <functional>
 #include <map>
 #include <string>
 
diff --git a/storage/innobase/sync/sync0debug.cc b/storage/innobase/sync/sync0debug.cc
index 0cbea6e7733..e3a633be86e 100644
--- a/storage/innobase/sync/sync0debug.cc
+++ b/storage/innobase/sync/sync0debug.cc
@@ -43,11 +43,12 @@ Created 2012-08-21 Sunny Bains
 #include "ut0new.h"
 #include "srv0start.h"
 
+#include <algorithm>
+#include <functional>
+#include <iostream>
 #include <map>
 #include <vector>
 #include <string>
-#include <algorithm>
-#include <iostream>
 
 #ifdef UNIV_DEBUG
 
diff --git a/storage/myisam/sort.cc b/storage/myisam/sort.cc
index fc54f6f2a7c..a81feee1343 100644
--- a/storage/myisam/sort.cc
+++ b/storage/myisam/sort.cc
@@ -28,6 +28,7 @@
 */
 
 #include <algorithm>
+#include <functional>
 
 #include "fulltext.h"
 #if defined(_WIN32)

